package com.casic.dcms.view.statistics;

import android.content.Context;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.RadioGroup;

import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.ActivityTrendAnalysisBinding;
import com.casic.dcms.model.CaseTendencyBean;
import com.casic.dcms.utils.ChartViewHelper;
import com.casic.dcms.utils.ColorHub;
import com.casic.dcms.utils.DialogHelper;
import com.casic.dcms.utils.LocaleConstant;
import com.casic.dcms.utils.TimeOrDateUtil;
import com.casic.dcms.vm.DataAnalysisViewModel;
import com.casic.dcms.widgets.RangeDateActionSheet;
import com.github.mikephil.charting.data.Entry;
import com.gyf.immersionbar.ImmersionBar;
import com.pengxh.androidx.lite.adapter.NormalRecyclerAdapter;
import com.pengxh.androidx.lite.adapter.ViewHolder;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.divider.ItemDecoration;
import com.pengxh.androidx.lite.hub.FloatHub;
import com.pengxh.androidx.lite.hub.IntHub;
import com.pengxh.androidx.lite.hub.LongHub;
import com.pengxh.androidx.lite.utils.ImmerseStatusBarManager;
import com.pengxh.androidx.lite.vm.LoadState;

import java.util.ArrayList;
import java.util.List;

public class TrendAnalysisActivity extends AndroidxBaseActivity<ActivityTrendAnalysisBinding> {

    private static final String TAG = "TrendAnalysisActivity";
    private final Context context = TrendAnalysisActivity.this;
    private DataAnalysisViewModel dataAnalysisViewModel;

    @Override
    protected void setupTopBarLayout() {
        ImmerseStatusBarManager.setColor(this, IntHub.convertColor(this, R.color.white));
        ImmersionBar.with(this).statusBarDarkFont(true).init();

        viewBinding.titleBarLayout.titleView.setText(LocaleConstant.ANALYSIS_ITEMS.get(5));
        viewBinding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {
        dataAnalysisViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    DialogHelper.showLoadingDialog(context, "数据加载中，请稍后");
                } else {
                    DialogHelper.dismissLoadingDialog();
                }
            }
        });
    }

    @Override
    protected void initData() {
        dataAnalysisViewModel = new ViewModelProvider(this).get(DataAnalysisViewModel.class);
        dataAnalysisViewModel.caseTendencyData.observe(this, new Observer<CaseTendencyBean>() {
            @Override
            public void onChanged(CaseTendencyBean caseTendencyBean) {
                if (caseTendencyBean.getCode() == 200) {
                    List<CaseTendencyBean.DataModel> dataModels = caseTendencyBean.getData();
                    int caseCount = 0;
                    List<String> dates = new ArrayList<>();
                    List<Entry> registeredEntries = new ArrayList<>();
                    List<Entry> distributeEntries = new ArrayList<>();
                    List<Entry> processEntries = new ArrayList<>();
                    List<Entry> closedEntries = new ArrayList<>();
                    for (int i = 0; i < dataModels.size(); i++) {
                        CaseTendencyBean.DataModel dataModel = dataModels.get(i);

                        caseCount += Integer.parseInt(dataModel.getRegisteredNum());

                        dates.add(dataModel.getStatisticsTime());
                        registeredEntries.add(new Entry(i, Float.parseFloat(dataModel.getRegisteredNum()), "Registered"));
                        distributeEntries.add(new Entry(i, Float.parseFloat(dataModel.getDistributeNum()), "Distribute"));
                        processEntries.add(new Entry(i, Float.parseFloat(dataModel.getProcessNum()), "Process"));
                        closedEntries.add(new Entry(i, Float.parseFloat(dataModel.getClosedNum()), "Closed"));
                    }
                    viewBinding.caseCountView.setText("立案数：" + caseCount);

                    ChartViewHelper.setLineChartData(viewBinding.lineChart, dates, registeredEntries, distributeEntries, processEntries, closedEntries);

                    NormalRecyclerAdapter<CaseTendencyBean.DataModel> recyclerAdapter = new NormalRecyclerAdapter<CaseTendencyBean.DataModel>(R.layout.item_alanysis_rv_l, dataModels) {

                        @Override
                        public void convertView(ViewHolder viewHolder, int position, CaseTendencyBean.DataModel item) {
                            //设置随机颜色
                            int[] color = ColorHub.generateColor(context);

                            viewHolder.setText(R.id.numberTagView, String.valueOf(position + 1))
                                    .setBackgroundColor(R.id.numberTagView, color[0])
                                    .setTextColor(R.id.numberTagView, color[1])
                                    .setText(R.id.caseSourceView, item.getStatisticsTime())
                                    .setText(R.id.caseNumView, item.getRegisteredNum());

                            ProgressBar progressBar = viewHolder.getView(R.id.frequencyProgressBar);
                            float v = Float.parseFloat(item.getClosedNum()) / Integer.parseInt(item.getRegisteredNum());
                            progressBar.setProgress((int) (v * 100));
                        }
                    };
                    viewBinding.trendAnalysisView.addItemDecoration(new ItemDecoration(FloatHub.dp2px(context, 75), FloatHub.dp2px(context, 15)));
                    viewBinding.trendAnalysisView.setAdapter(recyclerAdapter);
                }
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();
        //默认加载当前时间往前一个月的
        dataAnalysisViewModel.getCaseTendency(TimeOrDateUtil.getOneMonthDate(), LongHub.timestampToDate(System.currentTimeMillis()));
    }

    @Override
    protected void initEvent() {
        viewBinding.selectCalendarButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new RangeDateActionSheet.Builder().setContext(context).setOnActionSheetListener(new RangeDateActionSheet.OnDateRangeSelectedListener() {
                    @Override
                    public void onDateRangeSelected(String startDate, String endDate) {
                        dataAnalysisViewModel.getCaseTendency(startDate, endDate);
                    }
                }).build().show();
            }
        });

        viewBinding.radioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if (checkedId == R.id.oneMonthRadioButton) {
                    dataAnalysisViewModel.getCaseTendency(TimeOrDateUtil.getOneMonthDate(), LongHub.timestampToDate(System.currentTimeMillis()));
                } else if (checkedId == R.id.threeMonthRadioButton) {
                    dataAnalysisViewModel.getCaseTendency(TimeOrDateUtil.getThreeMonthDate(), LongHub.timestampToDate(System.currentTimeMillis()));
                } else {
                    dataAnalysisViewModel.getCaseTendency(TimeOrDateUtil.getSixMonthDate(), LongHub.timestampToDate(System.currentTimeMillis()));
                }
            }
        });
    }
}
